Index: libstdc++-v3/testsuite/25_algorithms/clamp/1.cc
===================================================================
--- libstdc++-v3/testsuite/25_algorithms/clamp/1.cc	(.../tags/gcc_7_2_0_release)
+++ libstdc++-v3/testsuite/25_algorithms/clamp/1.cc	(.../branches/gcc-7-branch)
@@ -30,12 +30,12 @@
   VERIFY( y == 3 );
   VERIFY( z == 4 );
 
-  const int xc = std::clamp(1, 2, 4, std::greater<int>());
-  const int yc = std::clamp(3, 2, 4, std::greater<int>());
-  const int zc = std::clamp(5, 2, 4, std::greater<int>());
-  VERIFY( xc == 4 );
-  VERIFY( yc == 2 );
-  VERIFY( zc == 2 );
+  const int xc = std::clamp(1, 4, 2, std::greater<int>());
+  const int yc = std::clamp(3, 4, 2, std::greater<int>());
+  const int zc = std::clamp(5, 4, 2, std::greater<int>());
+  VERIFY( xc == 2 );
+  VERIFY( yc == 3 );
+  VERIFY( zc == 4 );
 }
 
 int
Index: libstdc++-v3/testsuite/25_algorithms/clamp/constexpr.cc
===================================================================
--- libstdc++-v3/testsuite/25_algorithms/clamp/constexpr.cc	(.../tags/gcc_7_2_0_release)
+++ libstdc++-v3/testsuite/25_algorithms/clamp/constexpr.cc	(.../branches/gcc-7-branch)
@@ -27,5 +27,5 @@
 # error "Feature-test macro for clamp has wrong value"
 #endif
 
-static_assert(std::clamp(2, 0, 1) == 1, "");
-static_assert(std::clamp(2, 0, 1, std::greater<int>()) == 0, "");
+static_assert(std::clamp(2, 0, 1) == 1);
+static_assert(std::clamp(2, 1, 0, std::greater<int>()) == 1);
Index: libstdc++-v3/testsuite/24_iterators/container_access.cc
===================================================================
--- libstdc++-v3/testsuite/24_iterators/container_access.cc	(.../tags/gcc_7_2_0_release)
+++ libstdc++-v3/testsuite/24_iterators/container_access.cc	(.../branches/gcc-7-branch)
@@ -1,4 +1,4 @@
-// { dg-do run }
+// { dg-do run { target c++1z } }
 // { dg-options "-std=gnu++17" }
 
 // Copyright (C) 2015-2017 Free Software Foundation, Inc.
@@ -62,7 +62,6 @@
   static_assert(s == 3);
   constexpr auto e = std::empty(il3);
   static_assert(!e);
-
 }
 
 void
Index: libstdc++-v3/testsuite/24_iterators/range_access.cc
===================================================================
--- libstdc++-v3/testsuite/24_iterators/range_access.cc	(.../tags/gcc_7_2_0_release)
+++ libstdc++-v3/testsuite/24_iterators/range_access.cc	(.../branches/gcc-7-branch)
@@ -17,7 +17,7 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 24.6.5, range access [iterator.range]
+// C++ 2011 24.6.5, range access [iterator.range]
 
 #include <iterator>
 
Index: libstdc++-v3/testsuite/24_iterators/range_access_cpp14.cc
===================================================================
--- libstdc++-v3/testsuite/24_iterators/range_access_cpp14.cc	(.../tags/gcc_7_2_0_release)
+++ libstdc++-v3/testsuite/24_iterators/range_access_cpp14.cc	(.../branches/gcc-7-branch)
@@ -17,7 +17,7 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// 24.6.5, range access [iterator.range]
+// C++ 2014 24.7, range access [iterator.range]
 
 #include <iterator>
 #include <vector>
Index: libstdc++-v3/testsuite/24_iterators/range_access_cpp17.cc
===================================================================
--- libstdc++-v3/testsuite/24_iterators/range_access_cpp17.cc	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ libstdc++-v3/testsuite/24_iterators/range_access_cpp17.cc	(.../branches/gcc-7-branch)
@@ -0,0 +1,57 @@
+// { dg-options "-std=gnu++17" }
+// { dg-do compile { target c++1z } }
+
+// Copyright (C) 2017 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+// C++ 2017 27.7, range access [iterator.range]
+
+#include <iterator>
+
+void
+test01()
+{
+  using std::reverse_iterator;
+  static int i[1];
+  static_assert(std::cbegin(i) == i);
+  static_assert(std::cend(i) == i+1);
+  static_assert(std::rbegin(i) == reverse_iterator<int*>(i+1));
+  static_assert(std::rend(i) == reverse_iterator<int*>(i));
+  static_assert(std::crbegin(i) == reverse_iterator<int*>(i+1));
+  static_assert(std::crend(i) == reverse_iterator<int*>(i));
+}
+
+void
+test02()
+{
+  static int i[] = { 1, 2 };
+  static_assert(std::distance(std::begin(i), std::end(i)) == 2);
+  static_assert(std::distance(std::cbegin(i), std::cend(i)) == 2);
+}
+
+void
+test03()
+{
+  using std::reverse_iterator;
+  static constexpr std::initializer_list<int> il{1};
+  static_assert(std::cbegin(il) == il.begin());
+  static_assert(std::cend(il) == il.end());
+  static_assert(std::rbegin(il) == reverse_iterator<const int*>(il.end()));
+  static_assert(std::rend(il) == reverse_iterator<const int*>(il.begin()));
+  static_assert(std::crbegin(il) == reverse_iterator<const int*>(il.end()));
+  static_assert(std::crend(il) == reverse_iterator<const int*>(il.begin()));
+}
Index: libstdc++-v3/testsuite/ext/stdio_filebuf/char/81751.cc
===================================================================
--- libstdc++-v3/testsuite/ext/stdio_filebuf/char/81751.cc	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ libstdc++-v3/testsuite/ext/stdio_filebuf/char/81751.cc	(.../branches/gcc-7-branch)
@@ -0,0 +1,53 @@
+// Copyright (C) 2017 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+// { dg-require-fileio "" }
+
+#include <ext/stdio_filebuf.h>
+#include <cstdio>
+#include <cerrno>
+#include <testsuite_hooks.h>
+
+void
+test01()
+{
+  FILE* out = std::fopen("81751.txt", "w");
+  std::fwrite("Some words.", 1, 10, out);
+
+  FILE* in1 = std::fopen("81751.txt", "r");
+  __gnu_cxx::stdio_filebuf<char> buf1(in1, std::ios::in, BUFSIZ);
+  int c = buf1.sgetc();
+  VERIFY( c == std::char_traits<char>::eof() ); // PR libstdc++/81751
+
+  std::fflush(out);
+  FILE* in2 = std::fopen("81751.txt", "r");
+  __gnu_cxx::stdio_filebuf<char> buf2(in2, std::ios::in, BUFSIZ);
+  c = buf2.sgetc();
+  VERIFY( c == 'S' );
+
+  buf1.close();
+  buf2.close();
+  std::fclose(in1);
+  std::fclose(in2);
+  std::fclose(out);
+}
+
+int
+main()
+{
+  test01();
+}
Index: libstdc++-v3/testsuite/ext/stdio_filebuf/char/79820.cc
===================================================================
--- libstdc++-v3/testsuite/ext/stdio_filebuf/char/79820.cc	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ libstdc++-v3/testsuite/ext/stdio_filebuf/char/79820.cc	(.../branches/gcc-7-branch)
@@ -0,0 +1,39 @@
+// Copyright (C) 2017 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+// { dg-require-fileio "" }
+
+#include <ext/stdio_filebuf.h>
+#include <cstdio>
+#include <cerrno>
+#include <testsuite_hooks.h>
+
+void
+test01()
+{
+  FILE* f = std::fopen("79820.txt", "w");
+  std::fclose(f);
+  errno = 127;
+  __gnu_cxx::stdio_filebuf<char> b(f, std::ios::out, BUFSIZ);
+  VERIFY(errno == 127); // PR libstdc++/79820
+}
+
+int
+main()
+{
+  test01();
+}
Index: libstdc++-v3/testsuite/23_containers/unordered_map/cons/81891.cc
===================================================================
--- libstdc++-v3/testsuite/23_containers/unordered_map/cons/81891.cc	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ libstdc++-v3/testsuite/23_containers/unordered_map/cons/81891.cc	(.../branches/gcc-7-branch)
@@ -0,0 +1,68 @@
+// Copyright (C) 2017 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+// { dg-do run { target c++11 } }
+
+#include <unordered_map>
+#include <testsuite_hooks.h>
+#include <testsuite_allocator.h>
+
+struct fails_on_copy {
+  fails_on_copy() = default;
+  fails_on_copy(const fails_on_copy&) { throw 0; };
+};
+
+using value_type = std::pair<int, fails_on_copy>;
+
+void
+test01()
+{
+  value_type p;
+  try
+  {
+    std::unordered_map<int, fails_on_copy> umap(&p, &p + 1);
+  }
+  catch(...)
+  { }
+}
+
+void
+test02()
+{
+  using Alloc = __gnu_test::tracker_allocator<value_type>;
+  using std::hash;
+  using std::equal_to;
+
+  value_type p;
+  try
+  {
+    std::unordered_map<int, fails_on_copy, hash<int>, equal_to<int>, Alloc>
+	umap(&p, &p + 1);
+  }
+  catch(...)
+  { }
+
+  using counter = __gnu_test::tracker_allocator_counter;
+  VERIFY(counter::get_allocation_count() == counter::get_deallocation_count());
+}
+
+int
+main()
+{
+  test01();
+  test02();
+}
Index: libstdc++-v3/testsuite/27_io/basic_stringstream/assign/81338.cc
===================================================================
--- libstdc++-v3/testsuite/27_io/basic_stringstream/assign/81338.cc	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ libstdc++-v3/testsuite/27_io/basic_stringstream/assign/81338.cc	(.../branches/gcc-7-branch)
@@ -0,0 +1,40 @@
+// Copyright (C) 2017 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+// { dg-do run { target c++11 } }
+
+#include <sstream>
+#include <testsuite_hooks.h>
+
+void
+test01()
+{
+  std::stringstream ss;
+  for (int i = 0; i < 100; ++i)
+  {
+    ss << 'a';
+    VERIFY( static_cast<bool>(ss) );
+    VERIFY( ss.str() == "a" );
+    ss = std::stringstream();
+  }
+}
+
+int
+main()
+{
+  test01();
+}
Index: libstdc++-v3/testsuite/27_io/ios_base/storage/2.cc
===================================================================
--- libstdc++-v3/testsuite/27_io/ios_base/storage/2.cc	(.../tags/gcc_7_2_0_release)
+++ libstdc++-v3/testsuite/27_io/ios_base/storage/2.cc	(.../branches/gcc-7-branch)
@@ -26,11 +26,8 @@
 // Skip test at -m64 on Darwin because RLIMITS are not being honored.
 // Radar 6467883: 10.4/10.5 setrlimits are not honored by memory allocators
 // Radar 6467884: 10.X systems are not robust when paging space is exceeded
-// { dg-skip-if "" { *-*-darwin* && lp64 } { "*" } { "" } } 
+// { dg-skip-if "" { *-*-darwin* && lp64 } { "*" } { "" } }
 
-// The library throws the new definition of std::ios::failure
-// { dg-options "-D_GLIBCXX_USE_CXX11_ABI=1" }
-
 #include <sstream>
 #include <iostream>
 #include <limits>
@@ -52,12 +49,19 @@
   // pword
   ios.pword(1) = v;
   VERIFY( ios.pword(1) == v );
-  
-  try 
+
+  // The library throws the new definition of std::ios::failure
+#if _GLIBCXX_USE_CXX11_ABI
+    typedef std::ios_base::failure exception_type;
+#else
+    typedef std::exception exception_type;
+#endif
+
+  try
     {
       v = ios.pword(max);
     }
-  catch(std::ios_base::failure& obj)
+  catch(exception_type&)
     {
       // Ok.
       VERIFY( ios.bad() );
@@ -69,7 +73,7 @@
   VERIFY( v == 0 );
 
   VERIFY( ios.pword(1) == v );
-  
+
   // max is different code path from max-1
   v = &test;
   try
@@ -76,7 +80,7 @@
     {
       v = ios.pword(std::numeric_limits<int>::max());
     }
-  catch(std::ios_base::failure& obj)
+  catch(exception_type&)
     {
       // Ok.
       VERIFY( ios.bad() );
@@ -90,12 +94,12 @@
   // iword
   ios.iword(1) = 1;
   VERIFY( ios.iword(1) == 1 );
-  
-  try 
+
+  try
     {
       l = ios.iword(max);
     }
-  catch(std::ios_base::failure& obj)
+  catch(exception_type&)
     {
       // Ok.
       VERIFY( ios.bad() );
@@ -110,11 +114,11 @@
 
   // max is different code path from max-1
   l = 1;
-  try 
+  try
     {
       l = ios.iword(std::numeric_limits<int>::max());
     }
-  catch(std::ios_base::failure& obj)
+  catch(exception_type&)
     {
       // Ok.
       VERIFY( ios.bad() );
Index: libstdc++-v3/testsuite/27_io/basic_ios/copyfmt/char/1.cc
===================================================================
--- libstdc++-v3/testsuite/27_io/basic_ios/copyfmt/char/1.cc	(.../tags/gcc_7_2_0_release)
+++ libstdc++-v3/testsuite/27_io/basic_ios/copyfmt/char/1.cc	(.../branches/gcc-7-branch)
@@ -17,9 +17,6 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// The library throws the new definition of std::ios::failure
-// { dg-options "-D_GLIBCXX_USE_CXX11_ABI=1" }
-
 // 27.4.4.2 basic_ios member functions
 
 // NB: Don't include any other headers in this file.
@@ -36,13 +33,13 @@
   // basic_ios& copyfmt(const basic_ios& rhs)
   {
     std::ios ios_01(0);
-    std::ios ios_02(0);  
+    std::ios ios_02(0);
     ios_01.exceptions(std::ios_base::eofbit);
     ios_02.exceptions(std::ios_base::eofbit);
-    
+
     try {
-    ios_01.copyfmt(ios_02);
-    }		 
+      ios_01.copyfmt(ios_02);
+    }
     catch(...) {
       VERIFY( false );
     }
@@ -49,8 +46,15 @@
   }
 
   {
+    // The library throws the new definition of std::ios::failure
+#if _GLIBCXX_USE_CXX11_ABI
+    typedef std::ios_base::failure exception_type;
+#else
+    typedef std::exception exception_type;
+#endif
+
     std::ios ios_01(0);
-    std::ios ios_02(0);  
+    std::ios ios_02(0);
     ios_01.clear(std::ios_base::eofbit);
     ios_02.exceptions(std::ios_base::eofbit);
 
@@ -57,8 +61,8 @@
     try {
       ios_01.copyfmt(ios_02);
       VERIFY( false );
-    }		 
-    catch(std::ios_base::failure& fail) {
+    }
+    catch(exception_type&) {
       VERIFY( true );
     }
     catch(...) {
@@ -67,7 +71,7 @@
   }
 }
 
-int main() 
+int main()
 {
   test02();
   return 0;
Index: libstdc++-v3/testsuite/27_io/basic_ios/exceptions/char/1.cc
===================================================================
--- libstdc++-v3/testsuite/27_io/basic_ios/exceptions/char/1.cc	(.../tags/gcc_7_2_0_release)
+++ libstdc++-v3/testsuite/27_io/basic_ios/exceptions/char/1.cc	(.../branches/gcc-7-branch)
@@ -17,9 +17,6 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// The library throws the new definition of std::ios::failure
-// { dg-options "-D_GLIBCXX_USE_CXX11_ABI=1" }
-
 // 27.4.4.2 basic_ios member functions
 
 // NB: Don't include any other headers in this file.
@@ -44,7 +41,7 @@
     std::ios ios_01(0);
     try {
       ios_01.exceptions(std::ios_base::eofbit);
-    }		 
+    }
     catch(...) {
       VERIFY( false );
     }
@@ -53,13 +50,20 @@
   }
 
   {
+    // The library throws the new definition of std::ios::failure
+#if _GLIBCXX_USE_CXX11_ABI
+    typedef std::ios_base::failure exception_type;
+#else
+    typedef std::exception exception_type;
+#endif
+
     std::ios ios_01(0);
     ios_01.clear(std::ios_base::eofbit);
     try {
       ios_01.exceptions(std::ios_base::eofbit);
       VERIFY( false );
-    }		 
-    catch(std::ios_base::failure& fail) {
+    }
+    catch(exception_type&) {
       iostate02 = ios_01.exceptions();
       VERIFY( static_cast<bool>(iostate02 & std::ios_base::eofbit) );
     }
@@ -69,7 +73,7 @@
   }
 }
 
-int main() 
+int main()
 {
   test01();
   return 0;
Index: libstdc++-v3/testsuite/27_io/basic_fstream/53984.cc
===================================================================
--- libstdc++-v3/testsuite/27_io/basic_fstream/53984.cc	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ libstdc++-v3/testsuite/27_io/basic_fstream/53984.cc	(.../branches/gcc-7-branch)
@@ -0,0 +1,64 @@
+// Copyright (C) 2017 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+// { dg-require-fileio "" }
+
+// PR libstdc++/53984
+
+#include <fstream>
+#include <testsuite_hooks.h>
+
+void
+test01()
+{
+  std::ifstream in(".");
+  if (in)
+  {
+    char c;
+    if (in.get(c))
+    {
+      // Reading a directory doesn't produce an error on this target
+      // so the formatted input functions below wouldn't fail anyway
+      // (see PR libstdc++/81808).
+      return;
+    }
+    int x;
+    in.clear();
+    // Formatted input function should set badbit, but not throw:
+    in >> x;
+    VERIFY( in.bad() );
+
+    in.clear();
+    in.exceptions(std::ios::badbit);
+    try
+    {
+      // Formatted input function should set badbit, and throw:
+      in >> x;
+      VERIFY( false );
+    }
+    catch (const std::exception&)
+    {
+      VERIFY( in.bad() );
+    }
+  }
+}
+
+int
+main()
+{
+  test01();
+}
Index: libstdc++-v3/testsuite/27_io/basic_istream/sentry/wchar_t/12297.cc
===================================================================
--- libstdc++-v3/testsuite/27_io/basic_istream/sentry/wchar_t/12297.cc	(.../tags/gcc_7_2_0_release)
+++ libstdc++-v3/testsuite/27_io/basic_istream/sentry/wchar_t/12297.cc	(.../branches/gcc-7-branch)
@@ -15,9 +15,6 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// The library throws the new definition of std::ios::failure
-// { dg-options "-D_GLIBCXX_USE_CXX11_ABI=1" }
-
 // 27.6.1.1.2 class basic_istream::sentry
 
 #include <sstream>
@@ -28,16 +25,23 @@
   using namespace std;
   wistringstream stream;
   stream.exceptions(ios_base::eofbit);
-  
+
+  // The library throws the new definition of std::ios::failure
+#if _GLIBCXX_USE_CXX11_ABI
+    typedef std::ios_base::failure exception_type;
+#else
+    typedef std::exception exception_type;
+#endif
+
   try
     {
       wistream::sentry sentry(stream, false);
       VERIFY( false );
     }
-  catch (ios_base::failure&)
+  catch (exception_type&)
     {
       VERIFY( stream.rdstate() == (ios_base::eofbit | ios_base::failbit) );
     }
-  
+
   return 0;
 }
Index: libstdc++-v3/testsuite/27_io/basic_istream/sentry/char/53984.cc
===================================================================
--- libstdc++-v3/testsuite/27_io/basic_istream/sentry/char/53984.cc	(.../tags/gcc_7_2_0_release)	(nonexistent)
+++ libstdc++-v3/testsuite/27_io/basic_istream/sentry/char/53984.cc	(.../branches/gcc-7-branch)
@@ -0,0 +1,41 @@
+// Copyright (C) 2017 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// You should have received a copy of the GNU General Public License along
+// with this library; see the file COPYING3.  If not see
+// <http://www.gnu.org/licenses/>.
+
+#include <streambuf>
+#include <istream>
+#include <testsuite_hooks.h>
+
+struct SB : std::streambuf
+{
+  virtual int_type underflow() { throw 1; }
+};
+
+void
+test01()
+{
+  SB sb;
+  std::istream is(&sb);
+  int i;
+  is >> i;
+  VERIFY( is.bad() );
+}
+
+int
+main()
+{
+  test01();
+}
Index: libstdc++-v3/testsuite/27_io/basic_istream/sentry/char/12297.cc
===================================================================
--- libstdc++-v3/testsuite/27_io/basic_istream/sentry/char/12297.cc	(.../tags/gcc_7_2_0_release)
+++ libstdc++-v3/testsuite/27_io/basic_istream/sentry/char/12297.cc	(.../branches/gcc-7-branch)
@@ -15,12 +15,8 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-
 // 27.6.1.1.2 class basic_istream::sentry
 
-// The library throws the new definition of std::ios::failure
-// { dg-options "-D_GLIBCXX_USE_CXX11_ABI=1" }
-
 #include <sstream>
 #include <testsuite_hooks.h>
 
@@ -29,16 +25,23 @@
   using namespace std;
   istringstream stream;
   stream.exceptions(ios_base::eofbit);
-  
+
+  // The library throws the new definition of std::ios::failure
+#if _GLIBCXX_USE_CXX11_ABI
+    typedef std::ios_base::failure exception_type;
+#else
+    typedef std::exception exception_type;
+#endif
+
   try
     {
       istream::sentry sentry(stream, false);
       VERIFY( false );
     }
-  catch (ios_base::failure&)
+  catch (exception_type&)
     {
       VERIFY( stream.rdstate() == (ios_base::eofbit | ios_base::failbit) );
     }
-  
+
   return 0;
 }
Index: libstdc++-v3/testsuite/27_io/basic_istream/extractors_other/wchar_t/exceptions_null.cc
===================================================================
--- libstdc++-v3/testsuite/27_io/basic_istream/extractors_other/wchar_t/exceptions_null.cc	(.../tags/gcc_7_2_0_release)
+++ libstdc++-v3/testsuite/27_io/basic_istream/extractors_other/wchar_t/exceptions_null.cc	(.../branches/gcc-7-branch)
@@ -15,9 +15,6 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// The library throws the new definition of std::ios::failure
-// { dg-options "-D_GLIBCXX_USE_CXX11_ABI=1" }
-
 #include <istream>
 #include <ostream>
 #include <streambuf>
@@ -38,12 +35,19 @@
   wistringstream stream;
   stream.exceptions(ios_base::failbit);
 
+  // The library throws the new definition of std::ios::failure
+#if _GLIBCXX_USE_CXX11_ABI
+    typedef std::ios_base::failure exception_type;
+#else
+    typedef std::exception exception_type;
+#endif
+
   try
     {
       stream >> static_cast<wstreambuf*>(0);
       VERIFY( false );
     }
-  catch (ios_base::failure&)
+  catch (exception_type&)
     {
     }
 
Index: libstdc++-v3/testsuite/27_io/basic_istream/extractors_other/char/exceptions_null.cc
===================================================================
--- libstdc++-v3/testsuite/27_io/basic_istream/extractors_other/char/exceptions_null.cc	(.../tags/gcc_7_2_0_release)
+++ libstdc++-v3/testsuite/27_io/basic_istream/extractors_other/char/exceptions_null.cc	(.../branches/gcc-7-branch)
@@ -15,9 +15,6 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// The library throws the new definition of std::ios::failure
-// { dg-options "-D_GLIBCXX_USE_CXX11_ABI=1" }
-
 #include <istream>
 #include <ostream>
 #include <streambuf>
@@ -38,12 +35,19 @@
   istringstream stream;
   stream.exceptions(ios_base::failbit);
 
+  // The library throws the new definition of std::ios::failure
+#if _GLIBCXX_USE_CXX11_ABI
+    typedef std::ios_base::failure exception_type;
+#else
+    typedef std::exception exception_type;
+#endif
+
   try
     {
       stream >> static_cast<streambuf*>(0);
       VERIFY(false);
     }
-  catch (ios_base::failure&)
+  catch (exception_type&)
     {
     }
 
Index: libstdc++-v3/testsuite/27_io/basic_istream/extractors_arithmetic/wchar_t/exceptions_failbit.cc
===================================================================
--- libstdc++-v3/testsuite/27_io/basic_istream/extractors_arithmetic/wchar_t/exceptions_failbit.cc	(.../tags/gcc_7_2_0_release)
+++ libstdc++-v3/testsuite/27_io/basic_istream/extractors_arithmetic/wchar_t/exceptions_failbit.cc	(.../branches/gcc-7-branch)
@@ -15,9 +15,6 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// The library throws the new definition of std::ios::failure
-// { dg-options "-D_GLIBCXX_USE_CXX11_ABI=1" }
-
 #include <sstream>
 #include <testsuite_hooks.h>
 
@@ -29,7 +26,14 @@
 
   wistringstream stream(L"jaylib - champion sound");
   stream.exceptions(ios_base::failbit);
-  
+
+  // The library throws the new definition of std::ios::failure
+#if _GLIBCXX_USE_CXX11_ABI
+    typedef std::ios_base::failure exception_type;
+#else
+    typedef std::exception exception_type;
+#endif
+
   try
     {
       T i;
@@ -36,13 +40,13 @@
       stream >> i;
       VERIFY( false );
     }
-  catch (const ios_base::failure&)
-    { 
+  catch (const exception_type&)
+    {
       // stream should set failbit and throw ios_base::failure.
       VERIFY( stream.fail() );
       VERIFY( !stream.bad() );
       VERIFY( !stream.eof() );
-    }  
+    }
   catch(...)
     { VERIFY( false ); }
 }
Index: libstdc++-v3/testsuite/27_io/basic_istream/extractors_arithmetic/char/exceptions_failbit.cc
===================================================================
--- libstdc++-v3/testsuite/27_io/basic_istream/extractors_arithmetic/char/exceptions_failbit.cc	(.../tags/gcc_7_2_0_release)
+++ libstdc++-v3/testsuite/27_io/basic_istream/extractors_arithmetic/char/exceptions_failbit.cc	(.../branches/gcc-7-branch)
@@ -15,9 +15,6 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// The library throws the new definition of std::ios::failure
-// { dg-options "-D_GLIBCXX_USE_CXX11_ABI=1" }
-
 #include <sstream>
 #include <testsuite_hooks.h>
 
@@ -29,7 +26,14 @@
 
   istringstream stream("jaylib - champion sound");
   stream.exceptions(ios_base::failbit);
-  
+
+  // The library throws the new definition of std::ios::failure
+#if _GLIBCXX_USE_CXX11_ABI
+    typedef std::ios_base::failure exception_type;
+#else
+    typedef std::exception exception_type;
+#endif
+
   try
     {
       T i;
@@ -36,13 +40,13 @@
       stream >> i;
       VERIFY( false );
     }
-  catch (const ios_base::failure&)
-    { 
+  catch (const exception_type&)
+    {
       // stream should set failbit and throw ios_base::failure.
       VERIFY( stream.fail() );
       VERIFY( !stream.bad() );
       VERIFY( !stream.eof() );
-    }  
+    }
   catch(...)
     { VERIFY( false ); }
 }
Index: libstdc++-v3/testsuite/27_io/basic_ostream/inserters_other/wchar_t/exceptions_null.cc
===================================================================
--- libstdc++-v3/testsuite/27_io/basic_ostream/inserters_other/wchar_t/exceptions_null.cc	(.../tags/gcc_7_2_0_release)
+++ libstdc++-v3/testsuite/27_io/basic_ostream/inserters_other/wchar_t/exceptions_null.cc	(.../branches/gcc-7-branch)
@@ -15,9 +15,6 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// The library throws the new definition of std::ios::failure
-// { dg-options "-D_GLIBCXX_USE_CXX11_ABI=1" }
-
 #include <istream>
 #include <ostream>
 #include <streambuf>
@@ -39,13 +36,20 @@
 
   wostringstream stream;
   stream.exceptions(ios_base::badbit);
-	
+
+  // The library throws the new definition of std::ios::failure
+#if _GLIBCXX_USE_CXX11_ABI
+    typedef std::ios_base::failure exception_type;
+#else
+    typedef std::exception exception_type;
+#endif
+
   try
     {
       stream << static_cast<wstreambuf*>(0);
       VERIFY( false );
     }
-  catch (ios_base::failure&)
+  catch (exception_type&)
     {
     }
 
Index: libstdc++-v3/testsuite/27_io/basic_ostream/inserters_other/char/exceptions_null.cc
===================================================================
--- libstdc++-v3/testsuite/27_io/basic_ostream/inserters_other/char/exceptions_null.cc	(.../tags/gcc_7_2_0_release)
+++ libstdc++-v3/testsuite/27_io/basic_ostream/inserters_other/char/exceptions_null.cc	(.../branches/gcc-7-branch)
@@ -15,9 +15,6 @@
 // with this library; see the file COPYING3.  If not see
 // <http://www.gnu.org/licenses/>.
 
-// The library throws the new definition of std::ios::failure
-// { dg-options "-D_GLIBCXX_USE_CXX11_ABI=1" }
-
 #include <istream>
 #include <ostream>
 #include <streambuf>
@@ -39,13 +36,20 @@
 
   ostringstream stream;
   stream.exceptions(ios_base::badbit);
-	
+
+  // The library throws the new definition of std::ios::failure
+#if _GLIBCXX_USE_CXX11_ABI
+    typedef std::ios_base::failure exception_type;
+#else
+    typedef std::exception exception_type;
+#endif
+
   try
     {
       stream << static_cast<streambuf*>(0);
       VERIFY( false );
     }
-  catch (ios_base::failure&)
+  catch (exception_type&)
     {
     }
 
Index: libstdc++-v3/testsuite/21_strings/basic_string_view/modifiers/remove_suffix/wchar_t/1.cc
===================================================================
--- libstdc++-v3/testsuite/21_strings/basic_string_view/modifiers/remove_suffix/wchar_t/1.cc	(.../tags/gcc_7_2_0_release)
+++ libstdc++-v3/testsuite/21_strings/basic_string_view/modifiers/remove_suffix/wchar_t/1.cc	(.../branches/gcc-7-branch)
@@ -33,10 +33,29 @@
   VERIFY( str0 == wstring_view{L"olympus mo"} );
 }
 
+constexpr bool
+test02()
+{
+  using std::wstring_view;
+
+  wstring_view str0{L"olympus mons"};
+  wstring_view::pointer p = str0.data();
+  str0.remove_suffix(2);
+  if ( str0.data() != p)
+    return false;
+  if ( str0.length() != 10 )
+    return false;
+  if ( str0 != wstring_view{L"olympus mo"} )
+    return false;
+
+  return true;
+}
+
 int
 main()
 { 
   test01();
+  static_assert( test02() );
 
   return 0;
 }
